import win32.windows;
import std.string;
import std.stdio;
import win32frame.WindowBase ;
import win32frame.ToolTip ;

ushort LOWORD(uint l){ return cast(ushort)(l & 0xffff); }
ushort HIWORD(uint l){ return cast(ushort)(l >>> 16)  ; }

class WindowObject : WindowBase {
  int winX=CW_USEDEFAULT ;
  int winY=CW_USEDEFAULT ;
  int winW=CW_USEDEFAULT ;
  int winH=CW_USEDEFAULT ;
  int style  =0 ;
  int exstyle=0 ;
  HWND[]     fitWND_List ;
  uint[HWND] fitWND_Flag ;
  HWND[]     bc_wmsize_List ; // WM_SIZEをブロードキャストするHWNDリスト
  ToolTip tooltip ;
  
  this( string name ) {
    super(name) ;
  }

  int setPosition(int x, int y, int w, int h){
    winX = x ;
    winY = y ;
    winW = w ;
    winH = h ;
    return(0) ;
  }

  int setStyle(int style){
    this.style=style ;
    return(0) ;
  }

  int addStyle(int addstyle){
    this.style |= addstyle ;
    return(0) ;
  }

  int setExStyle(int exstyle){
    this.exstyle=exstyle ;
    return(0) ;
  }

  int addExStyle(int addexstyle){
    this.exstyle |= addexstyle ;
    return(0) ;
  }

  int addObject(WindowObject WObj, HMENU hmenu, bool fitWidth=false, bool fitHeight=false ){
    HWND tmphwnd ;
    int  ret ;
    ret = WObj.create(this.hwnd, hmenu) ;
    tmphwnd = WObj.getHWND() ;
    if( tmphwnd != null ){
      if( fitWidth==true || fitHeight==true ){
	writef("add fitable Object : hwnd=%08x name=%s\n", cast(int)(tmphwnd), WObj.name) ;
	fitWND_List.length = fitWND_List.length+1 ;
	fitWND_List[(fitWND_List.length-1)]=tmphwnd ;
	fitWND_Flag[tmphwnd] = ((fitWidth==true) ? 1 : 0) + ((fitHeight==true) ? 2 : 0)  ;
      }
    }
    return( ret ) ;
  }

  int addToolTip(ToolTip TooltipOBJ){
    if( TooltipOBJ !is null ){
      int ret ;
      tooltip = TooltipOBJ ;
      ret = tooltip.create(this.hwnd) ;
      tooltip.setClientRect() ;
      return(ret) ;
    }
    return(-1) ;
  }

  int create(HWND phwnd, HMENU hmenu){
    return( lowcreate( exstyle, style, winX,winY,winW,winH, phwnd, hmenu) ) ;
  }

  override LRESULT preproc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch( msg ){
    case WM_CREATE :
      RECT rc ;
      GetClientRect( hwnd, &rc ) ;
      winX=0 ;
      winY=0 ;
      winW=rc.right  ;
      winH=rc.bottom ;
      break ;
      
    case WM_MOVE :
      winX=LOWORD(lp) ;
      winY=HIWORD(lp) ;
      break ;

    case WM_SIZE :
      winW=LOWORD(lp) ;
      winH=HIWORD(lp) ;
      
      RECT rc ;
      GetClientRect( hwnd, &rc ) ;
      RECT rc_parent ;
      GetWindowRect( hwnd, &rc_parent ) ;
      
      for( int i=fitWND_List.length-1 ; i>=0 ; i-- ){
	RECT rc_child ;
	GetWindowRect( fitWND_List[i], &rc_child ) ;
	rc_child.top    = rc_child.top    - rc_parent.top  ;
	rc_child.bottom = rc_child.bottom - rc_parent.top  ;
	rc_child.left   = rc_child.left   - rc_parent.left ;
	rc_child.right  = rc_child.right  - rc_parent.left ;
	
	switch( fitWND_Flag[fitWND_List[i]] ){
	case 1 : // fit Width
	  MoveWindow( cast(HWND)(fitWND_List[i]), 0,  rc_child.top, (rc.right - rc.left), (rc_child.bottom - rc_child.top) , true ) ;
	  break ;
	case 2 : // fit Height
	  MoveWindow( cast(HWND)(fitWND_List[i]), rc_child.left, 0, (rc_child.right - rc_child.left), (rc.bottom - rc.top) , true ) ;
	  break ;
	case 3 :
	  MoveWindow( cast(HWND)(fitWND_List[i]), 0,0, (rc.right - rc.left), (rc.bottom - rc.top) , true ) ;
	  break ;
	}
      }
      for( int i=bc_wmsize_List.length-1 ; i>=0 ; i-- ){
	SendMessage( cast(HWND)(bc_wmsize_List[i]), WM_SIZE, wp, lp);
      }
      break ;
      
    default : break ;
    }
    
    return( this.proc(hwnd , msg , wp , lp) ) ;
  }

  override LRESULT presubproc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    if( msg==WM_SIZE ){
      if( tooltip !is null ){
	tooltip.reNewClientRect() ;
      }
    }
    return( this.subproc(hwnd , msg , wp , lp) ) ;
  }

}
